﻿using System;
using System.Windows.Input;

namespace Polecenie
{
    class DanePrzelewu //POCO
    {
        public Konto KontoPłatnika, KontoOdbiorcy;
        public decimal Kwota;
        public bool Wykonany = false;
    }

    class Program
    {
        static void Main(string[] args)
        {
            try //powinno być wokół każdego przelewu osobno
            {
                Konto konto1 = new Konto(1, 100);
                Konto konto2 = new Konto(2, 150);

                konto1.WyświetlSaldo();
                konto2.WyświetlSaldo();

                //Konto.Przelew(konto1, konto2, 50);
                //IPolecenie polecenieA = new PoleceniePrzelewu(konto1, konto2, 50);
                //IPolecenie polecenieB = new PoleceniePrzelewu(konto2, konto1, 100);
                DanePrzelewu daneC = new DanePrzelewu()
                {
                    KontoPłatnika = konto1,
                    KontoOdbiorcy = konto2,
                    Kwota = 50
                };
                DanePrzelewu daneD = new DanePrzelewu()
                {
                    KontoPłatnika = konto2,
                    KontoOdbiorcy = konto1,
                    Kwota = 100
                };
                ICommand poleceniePrzelewu = new RelayCommand(
                    (object parametr) =>
                    {
                        DanePrzelewu dane = parametr as DanePrzelewu;
                        Konto.Przelew(dane.KontoPłatnika, dane.KontoOdbiorcy, dane.Kwota);
                        dane.Wykonany = true;
                    },
                    (object parametr) =>
                    {
                        DanePrzelewu dane = parametr as DanePrzelewu;
                        return !dane.Wykonany && dane.Kwota > 0;
                    });                

                void wykonajPolecenie(ICommand polecenie, DanePrzelewu dane)
                {
                    if (polecenie.CanExecute(dane)) polecenie.Execute(dane);
                    else throw new Exception("Polecenie nie może być zrealizowane");
                }

                wykonajPolecenie(poleceniePrzelewu, daneC);

                konto1.WyświetlSaldo();
                konto2.WyświetlSaldo();

                //Konto.Przelew(konto2, konto1, 100);
                //wykonajPolecenie(polecenieB);
                //wykonajPolecenie(polecenieA);
                wykonajPolecenie(poleceniePrzelewu, daneD);
                //wykonajPolecenie(poleceniePrzelewu, daneC);

                konto1.WyświetlSaldo();
                konto2.WyświetlSaldo();
            }
            catch (Exception exc)
            {
                Console.Error.WriteLine("Błąd: " + exc.Message);
            }
        }
    }
}
